/**
 * @license
 * Copyright (c) 2014 The Polymer Project Authors. All rights reserved.
 * This code may only be used under the BSD style license found at
 * http://polymer.github.io/LICENSE.txt
 * The complete set of authors may be found at
 * http://polymer.github.io/AUTHORS.txt
 * The complete set of contributors may be found at
 * http://polymer.github.io/CONTRIBUTORS.txt
 * Code distributed by Google as part of the polymer project is also
 * subject to an additional IP rights grant found at
 * http://polymer.github.io/PATENTS.txt
 */
import * as parse5 from 'parse5';
export interface Matcher {
    (node: parse5.ASTNode): boolean;
}
export declare const nonModuleScript: Matcher;
export declare const moduleScript: Matcher;
export declare const externalStyle: Matcher;
export declare const polymerExternalStyle: Matcher;
export declare const styleMatcher: Matcher;
export declare const targetMatcher: Matcher;
export declare const head: Matcher;
export declare const body: Matcher;
export declare const base: Matcher;
export declare const template: Matcher;
export declare const domModuleWithoutAssetpath: Matcher;
export declare const polymerElement: Matcher;
export declare const externalNonModuleScript: Matcher;
export declare const inlineNonModuleScript: Matcher;
export declare const externalModuleScript: Matcher;
export declare const eagerHtmlImport: Matcher;
export declare const lazyHtmlImport: Matcher;
export declare const htmlImport: Matcher;
export declare const stylesheetImport: Matcher;
export declare const hiddenDiv: Matcher;
export declare const inHiddenDiv: Matcher;
export declare const elementsWithUrlAttrsToRewrite: Matcher;
export declare const beforeHiddenDiv: (node: parse5.ASTNode) => boolean;
export declare const afterHiddenDiv: (node: parse5.ASTNode) => boolean;
export declare const orderedImperative: Matcher;
